/*
 * Copyright (C) Sapphirecode - All Rights Reserved
 * This file is part of Modelling which is released under MIT.
 * See file 'LICENSE' for full license details.
 * Created by Timo Hocker <timo@scode.ovh>, May 2020
 */

export abstract class ControlModel {
  protected data: Record<string, string|number|boolean> = {};

  public abstract get object(): Record<string, string|number|boolean>;
  public abstract set object(obj: Record<string, string|number|boolean>);

  public get (key: string): string|number|boolean {
    return this.data[key];
  }

  public set (key: string, value: string|number|boolean): void {
    this.data[key] = value;
  }

  public update (): void {
    this.verify ();
  }

  public abstract verify(): void;
}
